#include <stdio.h>
#include "mymalloc.h"
#include "itemlist.h"
#include "local.h"

char *ModuleName;
char* mysprintf(char *format, ...);

/****************************************************/
static int   counter = 0;
static char *base = "_loc";

char *next_local_var (void)
{
   return mysprintf ("%s%d",base,counter++);
}

/****************************************************/
local_data_t make_local_data (char *type, char *name)
{
   local_data_t res = mymalloc (sizeof (struct local_data_t));
   res->type = type;
   res->name = name;
   return res;
}

/****************************************************/
item_list_t local_data_list = NULL;
void reset_local_data_list (void)
{
   if (local_data_list == NULL) local_data_list = _make_item_list ();
   else _reset_item_list (local_data_list);
}
void add_local_data (char *type, char *name)
{
   _add_item_list (local_data_list,make_local_data (type,name));
}
void concat_local_data (item_list_t list)
{
   _concat_item_list (local_data_list,list);
}

/****************************************************/
static char *local_shape = "\
typedef struct %s_data_t\n\
{\n\
%s\
} *%s_data_t;\
";

char *beginning_of_local_data_structure = "";

static char *data_structure (void)
{
   item_cell_t cell;
   local_data_t param;
   char *body = beginning_of_local_data_structure;

   if (local_data_list != NULL &&
       _length_of_item_list (local_data_list) != 0)
   {
      cell = _first_cell (local_data_list);
      while (cell != NULL) {
         param = (local_data_t)_content_of_cell (cell);
	 body = mysprintf ("%s    %s %s;\n",body,param->type,param->name);
	 cell = _next_cell (cell);
      }
   }
   return mysprintf (local_shape,ModuleName,body,ModuleName);   
}

/****************************************************/
static char *data_name (void)
{
   return mysprintf ("%s_data_t",ModuleName);
}

static void create_h_file (char *name)
{
   FILE *file;
   char * h_name = mysprintf ("%s.h",name);
   char * macro = mysprintf ("%s_macro",name);
   file = fopen (h_name,"wt");
   if (file == NULL) {
      fprintf (stderr, "cannot open file: %s\n",h_name);
      return;
   }
   fprintf (file,"\n#ifndef %s\n#define %s\n",macro,macro);
   fprintf (file,data_structure ());
   fprintf (file,"\n#endif\n");
   fclose (file);
}

int intern_data_structure = 0;

char *local_data_structure (void)
{
   char *name;
   if (intern_data_structure) return data_structure ();
   name = data_name ();
   create_h_file (name);
   return mysprintf ("\n#include \"%s.h\"\n",name);
}

/****************************************************/
